#ifndef PIE_MENU_INCLUDED
#define PIE_MENU_INCLUDED

#include <xsi_toolcontext.h>
#ifndef linux
#define WIN32_LEAN_AND_MEAN
#include <windows.h> // Needed for OpenGL on windows
#endif


#include <string.h>
#include <time.h>
#include <vector>

#include "ToolButton.h"

using namespace XSI; 
using namespace std;

////////////////////////////////////////////////////////////////////////////////
//
// Pie Menu class
//
////////////////////////////////////////////////////////////////////////////////

class PieMenu {
public:
	struct		spoint { LONG x,y;};

	PieMenu();
	~PieMenu();
	void		Setup( double in_r, LONG in_count, CString in_folderpath, CString in_pluginPath, LONG in_selectionIndex=0 );
	void		Cleanup();
	void		SetRadius(double in_r) { m_maxRadius = in_r; }	
	double		GetRadius() {return m_maxRadius;}
	void		SetPosition( LONG x, LONG y) { m_center.x=x;m_center.y=y;}
	void		SetSelection(ToolContext &in_ctxt, LONG mousex,LONG mousey);
	void		SetSelection(LONG in_index) {m_selectedIndex = in_index;CleanButtonSelectionData();};
	LONG		GetSelectionIndex() {return m_selectedIndex;}
	CString		GetSelectionName() {return m_buttons[m_selectedIndex].GetName();};
	void		Draw( ToolContext &in_ctxt );
	

private: // Implementation
	void	constructCircle (double in_r, spoint in_center, vector <spoint> &out_points);
	void	lerp(spoint& dest, const spoint& a, const spoint& b, const double t);
	void	AddButtons();
	void	CleanButtonSelectionData();
private: // Data
	CString		m_folderpath;	//button graphics
	CString		m_pluginPath;	
	LONG		m_buttonCount;		// Total number of buttons
	spoint		m_center;				// centre
	double		m_maxRadius;			// sphere radius
	LONG			m_selectedIndex;
	vector<spoint>	m_menuPoints;
	vector<ToolButton>	m_buttons;
};

#endif // PIE MENU INCLUDED
